// infinitescroll: 3DS edition
// by cubee

// include stuff
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <3ds.h>

int main() {

  // init variables
  int x = 0;
  int y = 0;
  int z = 0;
  int tr = 0;
  int cl = 0;
  int l = 2;
  int t = 2;
  int uplvl = 16;
  int sealvl = 6;

  int tree = 0;
  int flower = 0;
  int cloud = 0;

  // set random seed
  srand(time(0));

  // Initializes 3DS to do GFX???
  gfxInitDefault();

  // Create a console (text screen) on the Bottom Screen
  consoleInit(GFX_TOP, NULL);

  printf("infinitescroll - Ascii Terrain Generator.");

  // Main loop
  while (aptMainLoop()) {
    x = 0;

    // Set character for ground
    z = rand()%3-1;
    if (z == 1) {
      l = 2;
    } else if (z == -1) {
      l = 0;
    } else {
      l = 1;
    }

    // Trees
    tree = 0;
    flower = 0;
    cloud = 0;
    if (rand()%6+1 == 1) {
      tr = rand()%5+1;
      tree = 1;
    }
    // Flowers
    else if (rand()%3+1 == 1) {
      flower = 1;
    }

    // Clouds
    if (rand()%4+1 == 1) {
      cl = rand()%8+6;
      cloud = 1;
    }

    // Move terrain
    y += z;

    // Height limits
    if (y > uplvl) {
      y = uplvl;
      l = 1;
    }

    if (y <= sealvl) {
      y = sealvl;
      l = 3;
      t = 1;
    } else {
      t = 2;
    }

    // Print ground
    for (x = 0; x < y; x++) {
      if (t == 1) {
        printf(" ");
      } else {
        printf("_");
      }
    }
    if (l == 3) {
      printf("(");
    } else if (l == 2) {
      printf("\\");
    } else if (l == 1) {
      printf("|");
    } else {
      printf("_/");
    }
    //printf("%d", y);

    // Print plants on land
    if (! (y == sealvl)) {
      if (tree) {
        for (x = 0; x < tr; x++) {
          printf("=");
        }
        printf("()");
      } else if (flower) {
        printf("*");
      }
    }

    // Print clouds
    if (cloud) {
      for (x = 0; x < cl; x++) {
        printf(" ");
      }
      printf("@");
    }

    printf("\n");

    sleep(1);

    // Scan for input
    hidScanInput();

    // Handle input events
    u32 kDown = hidKeysDown();

    if (kDown & KEY_START) {
      break; // break in order to return to hbmenu
    }

  } // End loop

  //int C2D_Fini();
  gfxExit();
  return 0;
}
